/*
* React Tooltip
* {@link https://github.com/ReactTooltip/react-tooltip}
* @copyright ReactTooltip Team
* @license MIT
*/
import e,{createContext as t,useState as r,useCallback as o,useMemo as n,useContext as l,useRef as c,useEffect as i,useLayoutEffect as a}from"react";import s from"classnames";import{arrow as d,computePosition as u,offset as p,flip as m,shift as v}from"@floating-ui/dom";const y="react-tooltip-core-styles",f="react-tooltip-base-styles",h={core:!1,base:!1};function w({css:e,id:t=f,type:r="base",ref:o}){"core"===r&&(t=y),o||(o={});const{insertAt:n}=o;if(!e||"undefined"==typeof document||h[r])return;if(document.getElementById(t))return void console.warn(`[react-tooltip] Element with id '${t}' already exists. Call \`removeStyle()\` first`);const l=document.head||document.getElementsByTagName("head")[0],c=document.createElement("style");c.id=t,c.type="text/css","top"===n&&l.firstChild?l.insertBefore(c,l.firstChild):l.appendChild(c),c.styleSheet?c.styleSheet.cssText=e:c.appendChild(document.createTextNode(e)),h[r]=!0}const b=(e,t,r)=>{let o=null;return function(...n){const l=()=>{o=null,r||e.apply(this,n)};r&&!o&&(e.apply(this,n),o=setTimeout(l,t)),r||(o&&clearTimeout(o),o=setTimeout(l,t))}},S="DEFAULT_TOOLTIP_ID",E={anchorRefs:new Set,activeAnchor:{current:null},attach:()=>{},detach:()=>{},setActiveAnchor:()=>{}},g=t({getTooltipData:()=>E}),_=({children:t})=>{const[l,c]=r({[S]:new Set}),[i,a]=r({[S]:{current:null}}),s=(e,...t)=>{c((r=>{var o;const n=null!==(o=r[e])&&void 0!==o?o:new Set;return t.forEach((e=>n.add(e))),{...r,[e]:new Set(n)}}))},d=(e,...t)=>{c((r=>{const o=r[e];return o?(t.forEach((e=>o.delete(e))),{...r}):r}))},u=o(((e=S)=>{var t,r;return{anchorRefs:null!==(t=l[e])&&void 0!==t?t:new Set,activeAnchor:null!==(r=i[e])&&void 0!==r?r:{current:null},attach:(...t)=>s(e,...t),detach:(...t)=>d(e,...t),setActiveAnchor:t=>((e,t)=>{a((r=>{var o;return(null===(o=r[e])||void 0===o?void 0:o.current)===t.current?r:{...r,[e]:t}}))})(e,t)}}),[l,i,s,d]),p=n((()=>({getTooltipData:u})),[u]);return e.createElement(g.Provider,{value:p},t)};function A(e=S){return l(g).getTooltipData(e)}const T=({tooltipId:t,children:r,className:o,place:n,content:l,html:a,variant:d,offset:u,wrapper:p,events:m,positionStrategy:v,delayShow:y,delayHide:f})=>{const{attach:h,detach:w}=A(t),b=c(null);return i((()=>(h(b),()=>{w(b)})),[]),e.createElement("span",{ref:b,className:s("react-tooltip-wrapper",o),"data-tooltip-place":n,"data-tooltip-content":l,"data-tooltip-html":a,"data-tooltip-variant":d,"data-tooltip-offset":u,"data-tooltip-wrapper":p,"data-tooltip-events":m,"data-tooltip-position-strategy":v,"data-tooltip-delay-show":y,"data-tooltip-delay-hide":f},r)},O="undefined"!=typeof window?a:i,L=e=>{if(!(e instanceof HTMLElement||e instanceof SVGElement))return!1;const t=getComputedStyle(e);return["overflow","overflow-x","overflow-y"].some((e=>{const r=t.getPropertyValue(e);return"auto"===r||"scroll"===r}))},x=e=>{if(!e)return null;let t=e.parentElement;for(;t;){if(L(t))return t;t=t.parentElement}return document.scrollingElement||document.documentElement},N=async({elementReference:e=null,tooltipReference:t=null,tooltipArrowReference:r=null,place:o="top",offset:n=10,strategy:l="absolute",middlewares:c=[p(Number(n)),m(),v({padding:5})],border:i})=>{if(!e)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};if(null===t)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};const a=c;return r?(a.push(d({element:r,padding:5})),u(e,t,{placement:o,strategy:l,middleware:a}).then((({x:e,y:t,placement:r,middlewareData:o})=>{var n,l;const c={left:`${e}px`,top:`${t}px`,border:i},{x:a,y:s}=null!==(n=o.arrow)&&void 0!==n?n:{x:0,y:0},d=null!==(l={top:"bottom",right:"left",bottom:"top",left:"right"}[r.split("-")[0]])&&void 0!==l?l:"bottom",u=i&&{top:{borderBottom:i,borderRight:i},right:{borderBottom:i,borderLeft:i},bottom:{borderTop:i,borderLeft:i},left:{borderTop:i,borderRight:i}}[r.split("-")[0]];let p=0;if(i){const e=`${i}`.match(/(\d+)px/);p=(null==e?void 0:e[1])?Number(e[1]):1}return{tooltipStyles:c,tooltipArrowStyles:{left:null!=a?`${a}px`:"",top:null!=s?`${s}px`:"",right:"",bottom:"",...u,[d]:`-${4+p}px`},place:r}}))):u(e,t,{placement:"bottom",strategy:l,middleware:a}).then((({x:e,y:t,placement:r})=>({tooltipStyles:{left:`${e}px`,top:`${t}px`},tooltipArrowStyles:{},place:r})))};var k="core-styles-module_tooltip__3vRRp",R="core-styles-module_fixed__pcSol",$="core-styles-module_arrow__cvMwQ",C="core-styles-module_noArrow__xock6",I="core-styles-module_clickable__ZuTTB",j="core-styles-module_show__Nt9eE",B={tooltip:"styles-module_tooltip__mnnfp",arrow:"styles-module_arrow__K0L3T",dark:"styles-module_dark__xNqje",light:"styles-module_light__Z6W-X",success:"styles-module_success__A2AKt",warning:"styles-module_warning__SCK0X",error:"styles-module_error__JvumD",info:"styles-module_info__BWdHW"};const D=({id:t,className:o,classNameArrow:n,variant:l="dark",anchorId:a,anchorSelect:d,place:u="top",offset:p=10,events:m=["hover"],openOnClick:v=!1,positionStrategy:y="absolute",middlewares:f,wrapper:h,delayShow:w=0,delayHide:S=0,float:E=!1,hidden:g=!1,noArrow:_=!1,clickable:T=!1,closeOnEsc:L=!1,closeOnScroll:D=!1,closeOnResize:H=!1,style:q,position:z,afterShow:W,afterHide:M,content:K,contentWrapperRef:P,isOpen:U,setIsOpen:X,activeAnchor:F,setActiveAnchor:V,border:Z,opacity:G})=>{const J=c(null),Q=c(null),Y=c(null),ee=c(null),[te,re]=r(u),[oe,ne]=r({}),[le,ce]=r({}),[ie,ae]=r(!1),[se,de]=r(!1),ue=c(!1),pe=c(null),{anchorRefs:me,setActiveAnchor:ve}=A(t),ye=c(!1),[fe,he]=r([]),we=c(!1),be=v||m.includes("click");O((()=>(we.current=!0,()=>{we.current=!1})),[]),i((()=>{if(!ie){const e=setTimeout((()=>{de(!1)}),150);return()=>{clearTimeout(e)}}return()=>null}),[ie]);const Se=e=>{we.current&&(e&&de(!0),setTimeout((()=>{we.current&&(null==X||X(e),void 0===U&&ae(e))}),10))};i((()=>{if(void 0===U)return()=>null;U&&de(!0);const e=setTimeout((()=>{ae(U)}),10);return()=>{clearTimeout(e)}}),[U]),i((()=>{ie!==ue.current&&(ue.current=ie,ie?null==W||W():null==M||M())}),[ie]);const Ee=(e=S)=>{ee.current&&clearTimeout(ee.current),ee.current=setTimeout((()=>{ye.current||Se(!1)}),e)},ge=e=>{var t;if(!e)return;const r=null!==(t=e.currentTarget)&&void 0!==t?t:e.target;if(!(null==r?void 0:r.isConnected))return V(null),void ve({current:null});w?(Y.current&&clearTimeout(Y.current),Y.current=setTimeout((()=>{Se(!0)}),w)):Se(!0),V(r),ve({current:r}),ee.current&&clearTimeout(ee.current)},_e=()=>{T?Ee(S||100):S?Ee():Se(!1),Y.current&&clearTimeout(Y.current)},Ae=({x:e,y:t})=>{N({place:u,offset:p,elementReference:{getBoundingClientRect:()=>({x:e,y:t,width:0,height:0,top:t,left:e,right:e,bottom:t})},tooltipReference:J.current,tooltipArrowReference:Q.current,strategy:y,middlewares:f,border:Z}).then((e=>{Object.keys(e.tooltipStyles).length&&ne(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&ce(e.tooltipArrowStyles),re(e.place)}))},Te=e=>{if(!e)return;const t=e,r={x:t.clientX,y:t.clientY};Ae(r),pe.current=r},Oe=e=>{ge(e),S&&Ee()},Le=e=>{var t;[document.querySelector(`[id='${a}']`),...fe].some((t=>null==t?void 0:t.contains(e.target)))||(null===(t=J.current)||void 0===t?void 0:t.contains(e.target))||(Se(!1),Y.current&&clearTimeout(Y.current))},xe=b(ge,50,!0),Ne=b(_e,50,!0);i((()=>{var e,t;const r=new Set(me);fe.forEach((e=>{r.add({current:e})}));const o=document.querySelector(`[id='${a}']`);o&&r.add({current:o});const n=()=>{Se(!1)},l=x(F),c=x(J.current);D&&(window.addEventListener("scroll",n),null==l||l.addEventListener("scroll",n),null==c||c.addEventListener("scroll",n)),H&&window.addEventListener("resize",n);const i=e=>{"Escape"===e.key&&Se(!1)};L&&window.addEventListener("keydown",i);const s=[];be?(window.addEventListener("click",Le),s.push({event:"click",listener:Oe})):(s.push({event:"mouseenter",listener:xe},{event:"mouseleave",listener:Ne},{event:"focus",listener:xe},{event:"blur",listener:Ne}),E&&s.push({event:"mousemove",listener:Te}));const d=()=>{ye.current=!0},u=()=>{ye.current=!1,_e()};return T&&!be&&(null===(e=J.current)||void 0===e||e.addEventListener("mouseenter",d),null===(t=J.current)||void 0===t||t.addEventListener("mouseleave",u)),s.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.addEventListener(e,t)}))})),()=>{var e,t;D&&(window.removeEventListener("scroll",n),null==l||l.removeEventListener("scroll",n),null==c||c.removeEventListener("scroll",n)),H&&window.removeEventListener("resize",n),be&&window.removeEventListener("click",Le),L&&window.removeEventListener("keydown",i),T&&!be&&(null===(e=J.current)||void 0===e||e.removeEventListener("mouseenter",d),null===(t=J.current)||void 0===t||t.removeEventListener("mouseleave",u)),s.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.removeEventListener(e,t)}))}))}}),[se,me,fe,L,m]),i((()=>{let e=null!=d?d:"";!e&&t&&(e=`[data-tooltip-id='${t}']`);const r=new MutationObserver((r=>{const o=[];r.forEach((r=>{if("attributes"===r.type&&"data-tooltip-id"===r.attributeName){r.target.getAttribute("data-tooltip-id")===t&&o.push(r.target)}if("childList"===r.type&&(F&&[...r.removedNodes].some((e=>{var t;return!!(null===(t=null==e?void 0:e.contains)||void 0===t?void 0:t.call(e,F))&&(de(!1),Se(!1),V(null),Y.current&&clearTimeout(Y.current),ee.current&&clearTimeout(ee.current),!0)})),e))try{const t=[...r.addedNodes].filter((e=>1===e.nodeType));o.push(...t.filter((t=>t.matches(e)))),o.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))}catch(e){}})),o.length&&he((e=>[...e,...o]))}));return r.observe(document.body,{childList:!0,subtree:!0,attributes:!0,attributeFilter:["data-tooltip-id"]}),()=>{r.disconnect()}}),[t,d,F]);const ke=()=>{z?Ae(z):E?pe.current&&Ae(pe.current):N({place:u,offset:p,elementReference:F,tooltipReference:J.current,tooltipArrowReference:Q.current,strategy:y,middlewares:f,border:Z}).then((e=>{we.current&&(Object.keys(e.tooltipStyles).length&&ne(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&ce(e.tooltipArrowStyles),re(e.place))}))};i((()=>{ke()}),[ie,F,K,q,u,p,y,z]),i((()=>{if(!(null==P?void 0:P.current))return()=>null;const e=new ResizeObserver((()=>{ke()}));return e.observe(P.current),()=>{e.disconnect()}}),[K,null==P?void 0:P.current]),i((()=>{var e;const t=document.querySelector(`[id='${a}']`),r=[...fe,t];F&&r.includes(F)||V(null!==(e=fe[0])&&void 0!==e?e:t)}),[a,fe,F]),i((()=>()=>{Y.current&&clearTimeout(Y.current),ee.current&&clearTimeout(ee.current)}),[]),i((()=>{let e=d;if(!e&&t&&(e=`[data-tooltip-id='${t}']`),e)try{const t=Array.from(document.querySelectorAll(e));he(t)}catch(e){he([])}}),[t,d]);const Re=!g&&K&&ie&&Object.keys(oe).length>0;return se?e.createElement(h,{id:t,role:"tooltip",className:s("react-tooltip",k,B.tooltip,B[l],o,`react-tooltip__place-${te}`,{[j]:Re,[R]:"fixed"===y,[I]:T}),style:{...q,...oe,opacity:void 0!==G&&Re?G:void 0},ref:J},K,e.createElement(h,{className:s("react-tooltip-arrow",$,B.arrow,n,{[C]:_}),style:le,ref:Q})):null},H=({content:t})=>e.createElement("span",{dangerouslySetInnerHTML:{__html:t}}),q=({id:t,anchorId:o,anchorSelect:n,content:l,html:a,render:s,className:d,classNameArrow:u,variant:p="dark",place:m="top",offset:v=10,wrapper:y="div",children:f=null,events:h=["hover"],openOnClick:w=!1,positionStrategy:b="absolute",middlewares:S,delayShow:E=0,delayHide:g=0,float:_=!1,hidden:T=!1,noArrow:O=!1,clickable:L=!1,closeOnEsc:x=!1,closeOnScroll:N=!1,closeOnResize:k=!1,style:R,position:$,isOpen:C,disableStyleInjection:I=!1,border:j,opacity:B,setIsOpen:q,afterShow:z,afterHide:W})=>{const[M,K]=r(l),[P,U]=r(a),[X,F]=r(m),[V,Z]=r(p),[G,J]=r(v),[Q,Y]=r(E),[ee,te]=r(g),[re,oe]=r(_),[ne,le]=r(T),[ce,ie]=r(y),[ae,se]=r(h),[de,ue]=r(b),[pe,me]=r(null),ve=c(I),{anchorRefs:ye,activeAnchor:fe}=A(t),he=e=>null==e?void 0:e.getAttributeNames().reduce(((t,r)=>{var o;if(r.startsWith("data-tooltip-")){t[r.replace(/^data-tooltip-/,"")]=null!==(o=null==e?void 0:e.getAttribute(r))&&void 0!==o?o:null}return t}),{}),we=e=>{const t={place:e=>{var t;F(null!==(t=e)&&void 0!==t?t:m)},content:e=>{K(null!=e?e:l)},html:e=>{U(null!=e?e:a)},variant:e=>{var t;Z(null!==(t=e)&&void 0!==t?t:p)},offset:e=>{J(null===e?v:Number(e))},wrapper:e=>{var t;ie(null!==(t=e)&&void 0!==t?t:y)},events:e=>{const t=null==e?void 0:e.split(" ");se(null!=t?t:h)},"position-strategy":e=>{var t;ue(null!==(t=e)&&void 0!==t?t:b)},"delay-show":e=>{Y(null===e?E:Number(e))},"delay-hide":e=>{te(null===e?g:Number(e))},float:e=>{oe(null===e?_:"true"===e)},hidden:e=>{le(null===e?T:"true"===e)}};Object.values(t).forEach((e=>e(null))),Object.entries(e).forEach((([e,r])=>{var o;null===(o=t[e])||void 0===o||o.call(t,r)}))};i((()=>{K(l)}),[l]),i((()=>{U(a)}),[a]),i((()=>{F(m)}),[m]),i((()=>{Z(p)}),[p]),i((()=>{J(v)}),[v]),i((()=>{Y(E)}),[E]),i((()=>{te(g)}),[g]),i((()=>{oe(_)}),[_]),i((()=>{le(T)}),[T]),i((()=>{ue(b)}),[b]),i((()=>{ve.current!==I&&console.warn("[react-tooltip] Do not change `disableStyleInjection` dynamically.")}),[I]),i((()=>{"undefined"!=typeof window&&window.dispatchEvent(new CustomEvent("react-tooltip-inject-styles",{detail:{disableCore:"core"===I,disableBase:I}}))}),[]),i((()=>{var e;const r=new Set(ye);let l=n;if(!l&&t&&(l=`[data-tooltip-id='${t}']`),l)try{document.querySelectorAll(l).forEach((e=>{r.add({current:e})}))}catch(e){console.warn(`[react-tooltip] "${l}" is not a valid CSS selector`)}const c=document.querySelector(`[id='${o}']`);if(c&&r.add({current:c}),!r.size)return()=>null;const i=null!==(e=null!=pe?pe:c)&&void 0!==e?e:fe.current,a=new MutationObserver((e=>{e.forEach((e=>{var t;if(!i||"attributes"!==e.type||!(null===(t=e.attributeName)||void 0===t?void 0:t.startsWith("data-tooltip-")))return;const r=he(i);we(r)}))})),s={attributes:!0,childList:!1,subtree:!1};if(i){const e=he(i);we(e),a.observe(i,s)}return()=>{a.disconnect()}}),[ye,fe,pe,o,n]),i((()=>{(null==R?void 0:R.border)&&console.warn("[react-tooltip] Do not set `style.border`. Use `border` prop instead."),j&&!CSS.supports("border",`${j}`)&&console.warn(`[react-tooltip] "${j}" is not a valid \`border\`.`),(null==R?void 0:R.opacity)&&console.warn("[react-tooltip] Do not set `style.opacity`. Use `opacity` prop instead."),B&&!CSS.supports("opacity",`${B}`)&&console.warn(`[react-tooltip] "${B}" is not a valid \`opacity\`.`)}),[]);let be=f;const Se=c(null);if(s){const t=s({content:null!=M?M:null,activeAnchor:pe});be=t?e.createElement("div",{ref:Se,className:"react-tooltip-content-wrapper"},t):null}else M&&(be=M);P&&(be=e.createElement(H,{content:P}));const Ee={id:t,anchorId:o,anchorSelect:n,className:d,classNameArrow:u,content:be,contentWrapperRef:Se,place:X,variant:V,offset:G,wrapper:ce,events:ae,openOnClick:w,positionStrategy:de,middlewares:S,delayShow:Q,delayHide:ee,float:re,hidden:ne,noArrow:O,clickable:L,closeOnEsc:x,closeOnScroll:N,closeOnResize:k,style:R,position:$,isOpen:C,border:j,opacity:B,setIsOpen:q,afterShow:z,afterHide:W,activeAnchor:pe,setActiveAnchor:e=>me(e)};return e.createElement(D,{...Ee})};"undefined"!=typeof window&&window.addEventListener("react-tooltip-inject-styles",(e=>{e.detail.disableCore||w({css:`:root{--rt-color-white:#fff;--rt-color-dark:#222;--rt-color-success:#8dc572;--rt-color-error:#be6464;--rt-color-warning:#f0ad4e;--rt-color-info:#337ab7;--rt-opacity:0.9}.core-styles-module_tooltip__3vRRp{visibility:hidden;position:absolute;top:0;left:0;pointer-events:none;opacity:0;transition:opacity 0.3s ease-out;will-change:opacity,visibility}.core-styles-module_fixed__pcSol{position:fixed}.core-styles-module_arrow__cvMwQ{position:absolute;background:inherit}.core-styles-module_noArrow__xock6{display:none}.core-styles-module_clickable__ZuTTB{pointer-events:auto}.core-styles-module_show__Nt9eE{visibility:visible;opacity:var(--rt-opacity)}`,type:"core"}),e.detail.disableBase||w({css:`
.styles-module_tooltip__mnnfp{padding:8px 16px;border-radius:3px;font-size:90%;width:max-content}.styles-module_arrow__K0L3T{width:8px;height:8px;transform:rotate(45deg)}.styles-module_dark__xNqje{background:var(--rt-color-dark);color:var(--rt-color-white)}.styles-module_light__Z6W-X{background-color:var(--rt-color-white);color:var(--rt-color-dark)}.styles-module_success__A2AKt{background-color:var(--rt-color-success);color:var(--rt-color-white)}.styles-module_warning__SCK0X{background-color:var(--rt-color-warning);color:var(--rt-color-white)}.styles-module_error__JvumD{background-color:var(--rt-color-error);color:var(--rt-color-white)}.styles-module_info__BWdHW{background-color:var(--rt-color-info);color:var(--rt-color-white)}`,type:"base"})}));export{q as Tooltip,_ as TooltipProvider,T as TooltipWrapper};
